(function(window, $) {
    $(function() {
        bEffectSlide = function() {
            this.wrap = null;
            this.list = null;
            this.effect = 'fade';
            this.animation = false;
            this.current = 0;
            this.swiper = null;
            this.admin = location.pathname.match(/\/admin\/template\//); //管理画面かどうかのフラグ
            return this.init();
        };
        bEffectSlide.prototype = {
            //初期化処理
            init: function() {
                this.wrap = $("#coverWrap");
                this.list = this.wrap.find('>*');
                this.loaded = 0;
                this.length = this.list.length;

                $(document).trigger("bCoverReady");

                return this;
            },
            setPosition: function() {
                return this;
            },
            start: function() {
                var self = this;
                var defer = $.Deferred();
                var sid = null;

                self.setPosition();

                this.list.find('img').each(function() {
                    if (0 < $(this).height()) {
                        self.loaded++;
                    } else {
                        $(this).on('load', function() {
                            self.loaded++;
                        });
                    }
                });

                sid = setInterval(function() {
                    if (self.loaded == self.length) {
                        defer.resolve();
                    }
                }, 10);

                defer.promise().done(function() {
                    clearInterval(sid);
                    self.list.each(function() {
                        var src = $(this).find('img').attr('src');
                        $(this).addClass('swiper-slide');
                        $(this).css({
                            backgroundImage: 'url(' + src + ')'
                        });
                        // $(this).find('img').hide();
                    });

                    this.current = self.length;
                    if (1 < self.list.length) {
                        self.slide();
                    }
                });
                window.bEffects = this;

                return this;
            },
            reset: function() {
                this.wrap = $("#coverWrap");
                this.list = this.wrap.find('>*');
                this.length = this.list.length;
                this.loaded = this.length;

                this.list.each(function() {
                    var src = $(this).find('img').attr('src');
                    $(this).addClass('swiper-slide');
                    $(this).css({
                        backgroundImage: 'url(' + src + ')'
                    });
                    $(this).find('img').hide();
                });

                if (1 < this.list.length) {
                    this.slide();
                    this.wrap.next().show();
                } else {
                    this.wrap.css({transform: ''});
                    this.wrap.next().hide();
                }

                return this;
            },
            stop: function() {
                if (this.swiper) {
                    this.swiper.destroy();
                    this.swiper = null;
                }
                return this;
            },
            scaleUp: function(element, duration, start, rate) {
                var self = this;
                var position = [
                    "left top", "center top", "right top",
                    "left center", "center", "right center",
                    "left bottom", "center bottom", "right bottom"
                ];
                var posNo = Math.round(Math.random() * 8);
                var scale = [[1, 1.06], [1.06,1]];
                var scaleNo = Math.round(Math.random() * 1);
                var a = scale[scaleNo];
                
                if(duration == null) {
                    duration = 0;
                }
                if(start == null) {
                    start = a[0];
                }
                if(rate == null) {
                    rate = a[1];
                }

                element.css({'transform-origin': position[posNo]});
                
                $.Animation({rate:start}, {rate:rate}, {duration: duration, easing: "linear"}).progress(function() {
                    element.css({transform: 'scale3d('+this.rate+', '+this.rate+', 1)'});
                });
            },
            slide: function(zero, reverse) {
                var self = this;
                this.swiper = new Swiper('#coverList', {
                    pagination: '.swiper-pagination-cover',
                    paginationClickable: true,
                    autoplay: cover_interval,
                    speed: cover_duration,
                    effect: self.effect,
                    slidesPerView: 1,
                    nextButton: '.swiper-button-next-cover',
                    prevButton: '.swiper-button-prev-cover',
                    autoplayDisableOnInteraction: false,
                    loop: true,
                    onImagesReady: function(_swiper) {
                        var max = 0;
                        // $(self.wrap).find('.swiper-slide').find('img').each(function() {
                        //     max = Math.max(max, $(this).height());
                        // });
                        // $(self.wrap).parent().height(max);
                        // $(self.wrap).parent().data('defaultHeight', max);
                        _swiper.update('reset');
                    },
                    onSlideChangeEnd: function(swiper){
                        // $(self.wrap).find(">*:not(.swiper-slide-active)").find("span").css({transform:"", 'transform-origin': ""});
                    },
                    onSlideChangeStart: function(swiper){
                        // self.scaleUp($(self.wrap).find(".swiper-slide-active>span"), cover_interval+cover_duration+cover_duration+200);
                    }
                });
                
                $(window).on("orientationchange", function() {
                    setTimeout(function(){
                        var max = 0;
                        // $(self.wrap).parent().height('auto');
                        // $(self.wrap).find('.swiper-slide').find('img').show();
                        // $(self.wrap).find('.swiper-slide').find('img').each(function() {
                        //     max = Math.max(max, $(this).height());
                        // });
                        // $(self.wrap).parent().height(max);
                        // $(self.wrap).parent().data('defaultHeight', max);
                        self.swiper.update('reset');
                    }, 10);
                });
            }
        };

        window.bEffectSlide = new bEffectSlide();
    });

})(window, jQuery);